query FundingAchReturns($input: FundingAchReturnInput!) {
fundingAchReturns(input: $input) {
items {
acceptor {
businessName
fundingAchReturns
id
name
reference
}
accountNumberEndingIn
accountOwnerName
accountOwnerType
accountType
activityDate
amount
currency
fundingAmount
fundingCurrency
fundsReleaseDate
fundsTransferDescriptor
fundsTransferId
id
organization {
businessName
capabilities
fundingAchReturns
id
legalName
name
phoneNumber
}
paymentId
perspective
reason
reasonCode
routingNumber
traceNumber
transactionActivityDate
transactionAmount
transactionDateTime
transactionId
transactionReference
transactionTraceNumber
transactionType
}
pageInfo {
hasNextPage
hasPreviousPage
}
}
}
{
"input": {
"paging": {
"skip": 0,
"take": 0
},
"where": {
"acceptorId": "f47ac10b-58cc-4372-a567-0e02b2c3d479",
"activityDate": "example",
"fundsReleaseDate": "example"
}
}
}
curl --request POST \
--url https://api.sandbox.com/graphql \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer <YOUR_ACCESS_TOKEN>' \
--data '{
"query": "query FundingAchReturns($input: FundingAchReturnInput!) {\n fundingAchReturns(input: $input) {\n items {\n acceptor {\n businessName\n fundingAchReturns\n id\n name\n reference\n }\n accountNumberEndingIn\n accountOwnerName\n accountOwnerType\n accountType\n activityDate\n amount\n currency\n fundingAmount\n fundingCurrency\n fundsReleaseDate\n fundsTransferDescriptor\n fundsTransferId\n id\n organization {\n businessName\n capabilities\n fundingAchReturns\n id\n legalName\n name\n phoneNumber\n }\n paymentId\n perspective\n reason\n reasonCode\n routingNumber\n traceNumber\n transactionActivityDate\n transactionAmount\n transactionDateTime\n transactionId\n transactionReference\n transactionTraceNumber\n transactionType\n }\n pageInfo {\n hasNextPage\n hasPreviousPage\n }\n }\n}",
"variables": {
"input": {
"paging": {
"skip": 0,
"take": 0
},
"where": {
"acceptorId": "f47ac10b-58cc-4372-a567-0e02b2c3d479",
"activityDate": "example",
"fundsReleaseDate": "example"
}
}
}
}'
{
"data": {
"fundingAchReturns": {
"items": [
{
"acceptor": {
"allocations": "example",
"authorizationSummaries": "example",
"billingDescriptor": "CLACKSWORTH KEYBOARDS",
"businessName": "Clacksworth Keyboards",
"fees": "example",
"feeSummaries": "example",
"fundingAchReturns": "example",
"fundingDisputeEvents": "example",
"fundingSummaries": "example",
"fundingTransactions": "example",
"id": "a1b2c3d4-e5f6-7890-abcd-ef1234567890",
"name": "Ben Torres",
"paymentTransactions": "example",
"paymentTransactionSummaries": "example",
"reference": "example"
},
"accountNumberEndingIn": "example",
"accountOwnerName": "example",
"accountOwnerType": "CONSUMER",
"accountType": "CHECKING",
"activityDate": "2026-01-15",
"amount": 0,
"currency": "example",
"fundingAmount": 0,
"fundingCurrency": "example",
"fundsReleaseDate": "2026-01-15",
"fundsTransferDescriptor": "example",
"fundsTransferId": "f47ac10b-58cc-4372-a567-0e02b2c3d479",
"id": "c9a1e2d3-4b5f-6789-0abc-def123456789",
"organization": {
"acceptorApplicationCounts": [
"example"
],
"acceptors": "example",
"achNotificationsOfChange": "example",
"achReturns": "example",
"allocations": "example",
"allowedMerchantCategories": [
"example"
],
"authorizationSummaries": "example",
"businessAddress": "example",
"businessName": "Clacksworth Keyboards",
"capabilities": [
"ACQUIRING"
],
"fees": "example",
"feeSummaries": "example",
"fundingAchReturns": "example",
"fundingDisbursementReturns": "example",
"fundingDisputeEvents": "example",
"fundingSummaries": "example",
"fundingTransactions": "example",
"id": "d8b2f3e4-5c6a-7890-1bcd-ef2345678901",
"legalName": "example",
"name": "Ben Torres",
"paymentTransactions": "example",
"paymentTransactionSummaries": "example",
"phoneNumber": "example",
"reportAvailability": [
"example"
],
"settings": "example"
},
"paymentId": "e7c3a4b5-6d7e-8901-2cde-f34567890123",
"perspective": "PARTNER",
"reason": "example",
"reasonCode": "R01",
"routingNumber": "example",
"traceNumber": "example",
"transactionActivityDate": "2026-01-15",
"transactionAmount": 0,
"transactionDateTime": "2026-01-15T14:30:00Z",
"transactionId": "b6d4e5f6-7a8b-9012-3def-456789012345",
"transactionReference": "example",
"transactionTraceNumber": "example",
"transactionType": "AUTHORIZATION"
}
],
"pageInfo": {
"hasNextPage": true,
"hasPreviousPage": true
}
}
}
}
Reporting
fundingAchReturns
An itemized list of financially impacting ACH returns occurring on the pertinent funds release dates. Use this report to track ACH return-related money-movements.
query FundingAchReturns($input: FundingAchReturnInput!) {
fundingAchReturns(input: $input) {
items {
acceptor {
businessName
fundingAchReturns
id
name
reference
}
accountNumberEndingIn
accountOwnerName
accountOwnerType
accountType
activityDate
amount
currency
fundingAmount
fundingCurrency
fundsReleaseDate
fundsTransferDescriptor
fundsTransferId
id
organization {
businessName
capabilities
fundingAchReturns
id
legalName
name
phoneNumber
}
paymentId
perspective
reason
reasonCode
routingNumber
traceNumber
transactionActivityDate
transactionAmount
transactionDateTime
transactionId
transactionReference
transactionTraceNumber
transactionType
}
pageInfo {
hasNextPage
hasPreviousPage
}
}
}
{
"input": {
"paging": {
"skip": 0,
"take": 0
},
"where": {
"acceptorId": "f47ac10b-58cc-4372-a567-0e02b2c3d479",
"activityDate": "example",
"fundsReleaseDate": "example"
}
}
}
curl --request POST \
--url https://api.sandbox.com/graphql \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer <YOUR_ACCESS_TOKEN>' \
--data '{
"query": "query FundingAchReturns($input: FundingAchReturnInput!) {\n fundingAchReturns(input: $input) {\n items {\n acceptor {\n businessName\n fundingAchReturns\n id\n name\n reference\n }\n accountNumberEndingIn\n accountOwnerName\n accountOwnerType\n accountType\n activityDate\n amount\n currency\n fundingAmount\n fundingCurrency\n fundsReleaseDate\n fundsTransferDescriptor\n fundsTransferId\n id\n organization {\n businessName\n capabilities\n fundingAchReturns\n id\n legalName\n name\n phoneNumber\n }\n paymentId\n perspective\n reason\n reasonCode\n routingNumber\n traceNumber\n transactionActivityDate\n transactionAmount\n transactionDateTime\n transactionId\n transactionReference\n transactionTraceNumber\n transactionType\n }\n pageInfo {\n hasNextPage\n hasPreviousPage\n }\n }\n}",
"variables": {
"input": {
"paging": {
"skip": 0,
"take": 0
},
"where": {
"acceptorId": "f47ac10b-58cc-4372-a567-0e02b2c3d479",
"activityDate": "example",
"fundsReleaseDate": "example"
}
}
}
}'
{
"data": {
"fundingAchReturns": {
"items": [
{
"acceptor": {
"allocations": "example",
"authorizationSummaries": "example",
"billingDescriptor": "CLACKSWORTH KEYBOARDS",
"businessName": "Clacksworth Keyboards",
"fees": "example",
"feeSummaries": "example",
"fundingAchReturns": "example",
"fundingDisputeEvents": "example",
"fundingSummaries": "example",
"fundingTransactions": "example",
"id": "a1b2c3d4-e5f6-7890-abcd-ef1234567890",
"name": "Ben Torres",
"paymentTransactions": "example",
"paymentTransactionSummaries": "example",
"reference": "example"
},
"accountNumberEndingIn": "example",
"accountOwnerName": "example",
"accountOwnerType": "CONSUMER",
"accountType": "CHECKING",
"activityDate": "2026-01-15",
"amount": 0,
"currency": "example",
"fundingAmount": 0,
"fundingCurrency": "example",
"fundsReleaseDate": "2026-01-15",
"fundsTransferDescriptor": "example",
"fundsTransferId": "f47ac10b-58cc-4372-a567-0e02b2c3d479",
"id": "c9a1e2d3-4b5f-6789-0abc-def123456789",
"organization": {
"acceptorApplicationCounts": [
"example"
],
"acceptors": "example",
"achNotificationsOfChange": "example",
"achReturns": "example",
"allocations": "example",
"allowedMerchantCategories": [
"example"
],
"authorizationSummaries": "example",
"businessAddress": "example",
"businessName": "Clacksworth Keyboards",
"capabilities": [
"ACQUIRING"
],
"fees": "example",
"feeSummaries": "example",
"fundingAchReturns": "example",
"fundingDisbursementReturns": "example",
"fundingDisputeEvents": "example",
"fundingSummaries": "example",
"fundingTransactions": "example",
"id": "d8b2f3e4-5c6a-7890-1bcd-ef2345678901",
"legalName": "example",
"name": "Ben Torres",
"paymentTransactions": "example",
"paymentTransactionSummaries": "example",
"phoneNumber": "example",
"reportAvailability": [
"example"
],
"settings": "example"
},
"paymentId": "e7c3a4b5-6d7e-8901-2cde-f34567890123",
"perspective": "PARTNER",
"reason": "example",
"reasonCode": "R01",
"routingNumber": "example",
"traceNumber": "example",
"transactionActivityDate": "2026-01-15",
"transactionAmount": 0,
"transactionDateTime": "2026-01-15T14:30:00Z",
"transactionId": "b6d4e5f6-7a8b-9012-3def-456789012345",
"transactionReference": "example",
"transactionTraceNumber": "example",
"transactionType": "AUTHORIZATION"
}
],
"pageInfo": {
"hasNextPage": true,
"hasPreviousPage": true
}
}
}
}
Query
Arguments
FundingAchReturnInput!
required
Show child attributes
Show child attributes
PagingInput!
required
See PagingInput
FundingAchReturnsFilterInput!
required
Show child attributes
Show child attributes
GuidFilterInput
See GuidFilterInput
DateRangeFilterInput
DateRangeFilterInput
GuidFilterInput
See GuidFilterInput
EnumFilterInputOfPerspectiveInput
Return type
FundingAchReturnOutputCollection
[FundingAchReturnOutput!]!
required
Show child attributes
Show child attributes
String
The last few numbers of the bank account used as a visual reference to the full account numer.
String
The name of the bank account owner, as provided by the NACHA report.
AccountOwnerType
The type of the bank account owner, as provided by the NACHA report.See AccountOwnerType
BankAccountType
The type of the bank account, e.g., Checking or Savings.See BankAccountType
Date!
required
The date Tesouro received the ach return.
Decimal!
required
The amount of the ach return.
String!
required
The currency specified on the ach return.
Decimal
The funded amount of the ACH return.
String
The currency associated with the ACH return funding amount.
Date
The date the debited or credited funds for the ACH return were released.
String
A value created by Tesouro and sent with the funds transfer to the recipient’s bank for display on the bank statement. It includes information on who sent the money and the purpose of the payment. The recipient can use this value to help with bank and transaction reconciliation.
UUID
A unique identifier created by Tesouro and assigned to the transfer of money to a bank account for this ach return, that identifies a cohort of funded transactions making up the transfer.
UUID!
required
A unique identifier created by Tesouro and assigned to the ACH return resulting in the credit or debit.
Organization!
required
See Organization
UUID
A unique 36 character identifier created by Tesouro and assigned to a group of transactions in the same payment request cohort. e.g., An authorization request, incremental authorization request, and the final capture would have the same paymentID.
Perspective
The perspective of the money movement, which can be either ‘Acceptor’ or ‘Partner’. This field is used to determine the financial perspective from which the ACH return is reported.See Perspective
String!
required
Description of return reason.
AchReturnCode!
required
Nacha Return Codes and associated ISO Status Reason Codes for returns and reversals from the External Code List.See AchReturnCode
String!
required
A unique nine-digit number that identifies a bank and is used for electronic transactions. It’s also known as an ABA routing number, or routing transit number (RTN).
String!
required
A unique 15 digit reference number created by the bank and used to investigate and research ACH transfers and returns.
Date
The date Tesouro recognized the original ACH payment request, based upon the acceptor cutoff. Formatted as YYYY-MM-DD
Decimal!
required
The transaction amount submitted with the original ach request.
DateTime!
required
The date and time that Tesouro received the original ach transaction, in UTC. Formatted as 2024-03-27T02:40:00Z
UUID!
required
A unique identifier assigned by Tesouro to the original ach transaction.
String
A unique identifier from original ach transaction created by the entity holding the direct relationship with the Acceptor. Tesouro uses this identifier to manage idempotency.
String!
required
A number that a bank can you to investigate and research an ach transaction.
TransactionType!
required
The type of original ach transaction, e.g., Sale or Refund.See TransactionType
query FundingAchReturns($input: FundingAchReturnInput!) {
fundingAchReturns(input: $input) {
items {
acceptor {
businessName
fundingAchReturns
id
name
reference
}
accountNumberEndingIn
accountOwnerName
accountOwnerType
accountType
activityDate
amount
currency
fundingAmount
fundingCurrency
fundsReleaseDate
fundsTransferDescriptor
fundsTransferId
id
organization {
businessName
capabilities
fundingAchReturns
id
legalName
name
phoneNumber
}
paymentId
perspective
reason
reasonCode
routingNumber
traceNumber
transactionActivityDate
transactionAmount
transactionDateTime
transactionId
transactionReference
transactionTraceNumber
transactionType
}
pageInfo {
hasNextPage
hasPreviousPage
}
}
}
{
"input": {
"paging": {
"skip": 0,
"take": 0
},
"where": {
"acceptorId": "f47ac10b-58cc-4372-a567-0e02b2c3d479",
"activityDate": "example",
"fundsReleaseDate": "example"
}
}
}
curl --request POST \
--url https://api.sandbox.com/graphql \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer <YOUR_ACCESS_TOKEN>' \
--data '{
"query": "query FundingAchReturns($input: FundingAchReturnInput!) {\n fundingAchReturns(input: $input) {\n items {\n acceptor {\n businessName\n fundingAchReturns\n id\n name\n reference\n }\n accountNumberEndingIn\n accountOwnerName\n accountOwnerType\n accountType\n activityDate\n amount\n currency\n fundingAmount\n fundingCurrency\n fundsReleaseDate\n fundsTransferDescriptor\n fundsTransferId\n id\n organization {\n businessName\n capabilities\n fundingAchReturns\n id\n legalName\n name\n phoneNumber\n }\n paymentId\n perspective\n reason\n reasonCode\n routingNumber\n traceNumber\n transactionActivityDate\n transactionAmount\n transactionDateTime\n transactionId\n transactionReference\n transactionTraceNumber\n transactionType\n }\n pageInfo {\n hasNextPage\n hasPreviousPage\n }\n }\n}",
"variables": {
"input": {
"paging": {
"skip": 0,
"take": 0
},
"where": {
"acceptorId": "f47ac10b-58cc-4372-a567-0e02b2c3d479",
"activityDate": "example",
"fundsReleaseDate": "example"
}
}
}
}'
{
"data": {
"fundingAchReturns": {
"items": [
{
"acceptor": {
"allocations": "example",
"authorizationSummaries": "example",
"billingDescriptor": "CLACKSWORTH KEYBOARDS",
"businessName": "Clacksworth Keyboards",
"fees": "example",
"feeSummaries": "example",
"fundingAchReturns": "example",
"fundingDisputeEvents": "example",
"fundingSummaries": "example",
"fundingTransactions": "example",
"id": "a1b2c3d4-e5f6-7890-abcd-ef1234567890",
"name": "Ben Torres",
"paymentTransactions": "example",
"paymentTransactionSummaries": "example",
"reference": "example"
},
"accountNumberEndingIn": "example",
"accountOwnerName": "example",
"accountOwnerType": "CONSUMER",
"accountType": "CHECKING",
"activityDate": "2026-01-15",
"amount": 0,
"currency": "example",
"fundingAmount": 0,
"fundingCurrency": "example",
"fundsReleaseDate": "2026-01-15",
"fundsTransferDescriptor": "example",
"fundsTransferId": "f47ac10b-58cc-4372-a567-0e02b2c3d479",
"id": "c9a1e2d3-4b5f-6789-0abc-def123456789",
"organization": {
"acceptorApplicationCounts": [
"example"
],
"acceptors": "example",
"achNotificationsOfChange": "example",
"achReturns": "example",
"allocations": "example",
"allowedMerchantCategories": [
"example"
],
"authorizationSummaries": "example",
"businessAddress": "example",
"businessName": "Clacksworth Keyboards",
"capabilities": [
"ACQUIRING"
],
"fees": "example",
"feeSummaries": "example",
"fundingAchReturns": "example",
"fundingDisbursementReturns": "example",
"fundingDisputeEvents": "example",
"fundingSummaries": "example",
"fundingTransactions": "example",
"id": "d8b2f3e4-5c6a-7890-1bcd-ef2345678901",
"legalName": "example",
"name": "Ben Torres",
"paymentTransactions": "example",
"paymentTransactionSummaries": "example",
"phoneNumber": "example",
"reportAvailability": [
"example"
],
"settings": "example"
},
"paymentId": "e7c3a4b5-6d7e-8901-2cde-f34567890123",
"perspective": "PARTNER",
"reason": "example",
"reasonCode": "R01",
"routingNumber": "example",
"traceNumber": "example",
"transactionActivityDate": "2026-01-15",
"transactionAmount": 0,
"transactionDateTime": "2026-01-15T14:30:00Z",
"transactionId": "b6d4e5f6-7a8b-9012-3def-456789012345",
"transactionReference": "example",
"transactionTraceNumber": "example",
"transactionType": "AUTHORIZATION"
}
],
"pageInfo": {
"hasNextPage": true,
"hasPreviousPage": true
}
}
}
}
Was this page helpful?